#include <pic.h>

/*   

    " "
 PIC16F877A, DDS - AD9851

   EU1CC, .  e-mail: sferatv@softhome.net
http://eu1cc.boom.ru




       EEPROM
0  1  2  3  4  5  6  7   8   9   A   B   C   D   E   F
1  4  2  0  0  ,  0  0  rit att pre inv 


00   vfo A
10   vfo B 
20   S-metr
30  step
40
50  mem 1
60  mem 2
70  mem 3
80  mem 4
90  mem 5
A0  mem 6
B0  mem 7
C0  mem 8
D0  mem 9
E0  mem 10
F0  IF  


*/

// -----------------------  ------------------

char freq[8], promt[7];
char vfo;
unsigned long g,  k_sum, f_dds, IF, step;
bit split_on, rit_on, pr, at, old1, old2, new1, new2, agc, ssb, am, fm, cw, fast_flag ;
int bank1 s56, s57, s58, s59, s10, s20, s30, step_old, st, k, freq_old, mode, a;

// -----------------------  ---------------------------------
#define NOP  asm("NOP")
#define W_CLK RE2
#define FQ RE1
#define DATA RE0
#define	dds_strobe ((W_CLK = 1), (W_CLK = 0))		
#define	dds_update ((FQ = 1), (FQ = 0))	
#define tx RA1
#define val1 RB4
#define val2 RB5
#define E RC4   // LCD
#define RW RC3    
#define RS RC5
#define strobe ((E=1), (E=0))
#define ssb_pin RA4
#define SH RA2
#define ST RA3
#define DS RA5
#define hc_strobe ((SH=1), (SH=0))
#define hc_update ((ST=1), (ST=0))

// ------------------------------   --------------------
void att(void);
void pre(void);
void hc_595(void);
void mode_prog(void);
void read_if(void);

// -----------------------------  ---------------------------
// _______________________________________________________________________


// ------------------------------  -------------------------------
void delay(ms) //xtal 20MHz 1ms.                
   {int i; 
    for (i=0;i<ms*50;i++) NOP; }

// ----------------------------   LCD -----------------
void lcd_init()                                   
   {
     RS=0;         //
     delay(50);
     PORTD=0b00111000;
     delay(2);
     strobe;
     NOP;
     PORTD=0xFF;

     delay(20);
     PORTD=0b00111000;
     delay(2);
     strobe;
     NOP;
     PORTD=0xFF;

     delay(5);
     PORTD=0b00111000;
     delay(2);
     strobe;
     NOP;
     PORTD=0xFF;

     delay(20);
     PORTD=0b00001100;        // 00001 [ ] [ _ ] [ . ]
     delay(2);
     strobe;
     PORTD=0xFF;
     delay(100);
        }

// -------------------------------   LCD -----------------------
void lcd_busy()               
   {unsigned char regist;
    TRISD=0xFF;               //  D  
    RS=0;
    RW=1;
      while(1) 
            { E=1;
              regist=PORTD;
              E=0;
              regist &= 0x80;           
              if (regist == 0) break ;
            }
	RW = 0 ;			
	TRISD = 0x00 ;		
   }

// ---------------------------------    LCD --------------------------
void write(char c)                 
    {
     lcd_busy();
     RS = 1;	// write characters
     PORTD=c;
     strobe;
     RS = 0;
     PORTD=0xFF;
     }

// --------------------------------       ... ---------------
void cl(pos)                      //   ... 0x80 -    
     {                            // 0xC0 -  ,  
      lcd_busy();
      PORTD=pos;        
      strobe;
      PORTD=0xFF;
     }

// --------------------------------   ------------------------------------
void clear()                      
      {
      lcd_busy();
      PORTD=0b00000001;
      strobe;
      PORTD=0xFF;
}

// ----------------------------------    RIT ----------------------------
void lcd_rit()                    
    {cl(0x8D);
        write('R');
        write('I');
        write('T');
    
    }

// ---------------------------------------------------------- WRITE_ZNAK
void write_znak()                 //    S-
    {int tmp;
     lcd_busy();
     RS=0;
     RW=0;
     E=0;
     PORTD=0x40;                  //    
     strobe;
     lcd_busy();
     RS=1;


     for (tmp=0; tmp<7; tmp++) write(0);
     write(0x1F);
        
     for (tmp=0; tmp<7; tmp++) write(0);
     write(0x1F);
     
     for (tmp=0; tmp<7; tmp++) write(0);
     write(0x1F);
     
     for (tmp=0; tmp<7; tmp++) write(0);
     write(0x1F);
          
     for (tmp=0; tmp<6; tmp++) write(0);
     for (tmp=0; tmp<2; tmp++) write(0x1F);
     
     for (tmp=0; tmp<6; tmp++) write(0);
     for (tmp=0; tmp<2; tmp++) write(0x1F);
     
     for (tmp=0; tmp<5; tmp++) write(0);
     for (tmp=0; tmp<3; tmp++) write(0x1F);
     
    

/*     
//       S-     
     for (tmp=0; tmp<7; tmp++) write(0);
     write(0x1F);
        
     for (tmp=0; tmp<6; tmp++) write(0);
     write(0x1F);
     write(0x1F);
     
     for (tmp=0; tmp<5; tmp++) write(0); 
     for (tmp=0; tmp<3; tmp++) write(0x1F);

     for (tmp=0; tmp<4; tmp++) write(0);
     for (tmp=0; tmp<4; tmp++) write(0x1F);
     
     for (tmp=0; tmp<3; tmp++) write(0);
     for (tmp=0; tmp<5; tmp++) write(0x1F);
     
     for (tmp=0; tmp<2; tmp++) write(0);
     for (tmp=0; tmp<6; tmp++) write(0x1F);
     
     for (tmp=0; tmp<1; tmp++) write(0);
     for (tmp=0; tmp<7; tmp++) write(0x1F);
     
     for (tmp=0; tmp<8; tmp++) write(0x1F);
*/     
     
    }

// ---------------------------------------------- id10  ----------------------------------------
void id10()                              //    5611
  {

 
   if (freq[0]==0) 
          {if (freq[1]<3) PORTB=0;
                          
             else 
                  {if (freq[1]<5) PORTB=1;
                                   
                        else 
                           {if (freq[1]<8) PORTB=0x02;
                                                                             
                                            else PORTB=0x03;
                                               
                            }
                  }
          }
      if (freq[0]==1)
            {if (freq[1]<2) PORTB=0x03;
                             
                 else
                     {if (freq[1]<5) PORTB=0x04;
                                      
                            else PORTB=0x05;
                         
                     }
            }
      if (freq[0]>=2) PORTB=0x06;
             
      if (freq[0]==5) PORTB=0x07;
 
  }


// -------------------------------------------------------   LCD set  -------------
void lcd_set()         //   freq[],     LCD
     {int tmp;
       for (tmp=0; tmp<8; tmp++) write(freq[tmp]+0x30);
          
       if (freq[0] != freq_old)    //    
             {freq_old = freq[0];
              if (freq[0] == 0) ssb=1;
                  else ssb=0;
              ssb_pin = ssb;       //     1 - lsb, 0 - usb
              mode_prog();         //   LCD
             }
    

    if (rit_on) lcd_rit();  
 
    
    id10();
    
     }


// -------------------------------------------------------  DDS init  -------------
void dds_init()            //  DDS   
    {W_CLK=0;
     FQ=0;
     dds_strobe;
     dds_update;
    }

// -------------------------------------------------------  DDS set  ---------------
void dds_set(unsigned long f)    //    DDS 6x ,  0
  {int tmp;
   DATA = 0 ;  
   W_CLK=0;
   FQ=0;
   
   for (tmp = 0; tmp < 32; tmp++)
   	{  if (f & 1)
                DATA = 1;
             else DATA=0;   
            f >>= 1;
            dds_strobe;
  	}

	for (tmp = 0; tmp < 8; tmp++) dds_strobe ;
	W_CLK = 0 ;
	FQ = 0 ;
	dds_update ;
  }

// ---------------------------------------------------------------  KEY  -------------------
void key()                            //  

{int tmp=0;
 metka1:
    PORTD=0x00;                       //   = k
    RD2=1;
delay(tmp);
    if (RC0) k=7;
    if (RC1) k=4;
    if (RC2) k=1;
    RD2=0;
    RD3=1;
delay(tmp);
    if (RC0) k=8;
    if (RC1) k=5;
    if (RC2) k=2;
    RD3=0;
    RD4=1;
delay(tmp);
    if (RC0) k=9;
    if (RC1) k=6;
    if (RC2) k=3;
    RD4=0;
    RD5=1;
delay(tmp);
    if (RC0) k=0;
    if (RC1) k=15;  // fm/am
    if (RC2) k=14;  // ssb/cw
    RD5=0;
    RD0=1;
delay(tmp);    
    if (RC0) k=10;  // <
    if (RC1) k=17;  // fast
    if (RC2) k=16;  // agc
    RD0=0;
    RD1=1;
delay(tmp);    
    if (RC0) k=11;  // >
    if (RC1) k=13;  // pre
    if (RC2) k=12;  // att
    RD1=0;

    PORTD=0xFF;
    while (RC0 || RC1 || RC2) 
                {tmp=5;
                 goto metka1;
                }
 tmp=0;
 }

// -----------------------------------------------------------------------  F set -----------------
void f_set()         //  ,    DDS
{f_dds=0;
 f_dds=g*2147483648.0/100000000;
}

// -----------------------------------------------------------------------  F IF  -----------------
void f_if(long x)                   //    
  {g=0;
  g=(x+IF) / 10;
  }

// ----------------------------------------------------------------------- DDS sum -----------------
void dds_sum()           //   freq   
   {int tmp;
    long m=1000000,prom=0;
    k_sum=0;
    for (tmp=0; tmp<=7; tmp++)
         {if (tmp==5) tmp++;        // freq[5]  
          prom=freq[tmp]*m;
          m=m/10;
          k_sum=k_sum+prom;
         }
     k_sum=k_sum*10;                  //   1     
     g=(k_sum+IF) / 10;               //     
   }
// ------------------------------------------------------------  write VFO  -----------
void write_vfo()                     // write VFO A/B
   {int tmp, adr=0;
    if (vfo=='B') adr=0x10;    // VFO A   0x00, VFO B - 0x10
    
    for (tmp=0; tmp<=7; tmp++)           
         {if (tmp==5)               // freq[5]  
              {tmp++;
               adr++;
              }
          EEPROM_WRITE(adr, freq[tmp]);
          while (WR) NOP;           // ,    
          adr++;
          }
      adr++;                           //  mode
      EEPROM_WRITE(adr, mode);
      while (WR) NOP;
      
      adr++;                           //  
      EEPROM_WRITE(adr, pr);
      while (WR) NOP;
      
      adr++;                           //  ATT
      EEPROM_WRITE(adr, at);
      while (WR) NOP;
      
      
      
      
    }

// ------------------------------------------------------------  read VFO  ------------
void read_vfo()                      // read VFO A/B
   {int tmp, adr=0x00;
   if (vfo=='B') adr=0x10;
    for (tmp=0; tmp<=7; tmp++)
         {
          if (tmp==5) 
              {tmp++;
               adr++;
              }
          freq[tmp]=EEPROM_READ(adr);
          while (RD) NOP;
          adr++;
          
         }
     adr++;                        //  mode
     mode = EEPROM_READ(adr);
     while (RD) NOP;  
    
     adr++;                        //  
     pr = EEPROM_READ(adr);
     while (RD) NOP;  
    
     adr++;                        //  ATT
     at = EEPROM_READ(adr);
     while (RD) NOP;  
    
     att();
     pre();
     mode_prog();
   }
   
// ------------------------------------------------  LCD_SPLIT  -------------------------------------
void lcd_split()                      //     split
    {cl(0x8B);
        write('s');
        write('p');
        write('l');
        write('i');
        write('t');
    }

// ------------------------------------------------  SPLIT  -------------------------------------

void split()                         
  {int tmp;
   split_on=!split_on;
   if (split_on) lcd_split();
       
    else 
       {cl(0x8B);
        for (tmp=0; tmp<5; tmp++) write(' ');
       }
     
  }

// ------------------------------------------------------------------------  STEP_SET  ----------------
void step_set()                  //  
      {int tmp=0,j;  
        st=1;
        cl(0xC0);
           for (j=0; j<10; j++) write(' ');     //  11   
         cl(0xC0);
         write('S');
         write('t');
         write('e');
         write('p');
         write('>');
         
         delay(20);
         st=EEPROM_READ(0x30);                       //   
         while (RD) NOP;
                  
         switch (st)                                 //  
                 { case 1 : {write('1');
                             write('0');}
                             break;
                   case 2 : {write('2');
                             write('0');}
                             break;
                   case 3 : {write('3');
                             write('0');} 
                             break;
                   case 4 : {write('4');
                             write('0');}
                             break;
                   case 5 : {write('5'); 
                             write('0');}
                             break;
                   case 6 : {write('1');
                             write('0');
                             write('0');
                            }   break;
                   case 7 : {write('1');
                             write('k');
                             write('H');
                             write('z');
                            }   break;
                   case 8 : {write('1');
                             write('M');
                             write('H');
                             write('z');
                            }   break;         
                   default: {write('-');}
                        break;
                          }          // end case
                          
         
    metka1:
            k=33;   
            while (k==33)  key();
            
             if (k==10) st--;  //  
                       if (st==0) st=1;
             if (k==11) st++;
                       if (st==9) st=8;
             if (k==1) 
                   {EEPROM_WRITE(0x30, st);
                    while (WR) NOP;
                    delay(50);
                    cl(0xC0);
                    for (tmp=0; tmp<9; tmp++) write(' ');
                    }
              
           if (k==10 || k==11)
           { cl(0xC5);
             for (tmp=0; tmp<5; tmp++) write(' ');
              cl(0xC5);    
             switch (st)
                 { case 1 : {step=1;
                             write('1'); 
                             write('0');
                            }   break;
                   case 2 : {step=2;
                             write('2');
                             write('0');
                            }   break;
                   case 3 : {step=3;
                             write('3');
                             write('0');
                            }   break;
                   case 4 : {step=4;
                             write('4');
                             write('0');
                            }   break;
                   case 5 : {step=5;
                             write('5');
                             write('0');
                            }   break;
                   case 6 : {step=10;
                             write('1');
                             write('0');
                             write('0');
                            }   break;
                   case 7 : {step=100;
                             write('1');
                             write('k');
                             write('H');
                             write('z');
                            }   break;
                   case 8 : {step=100000;
                             write('1');
                             write('M');
                             write('H');
                             write('z');
                            }   break;         
                   default: step=1;
                        break;  }          // end case
                        
                           
                   goto metka1;     
            }     // end if     
           k=33;

          }



// ------------------------------------------------------------------------  F input --------------
void f_in()                           //   
  {int tmp;
   long m=1000000,prom,k_sum=0;
   
   
   cl(0xC0);
   write('F');                    //   LCD F>
   write('>');  

      for (tmp=0; tmp<=7; tmp++)      //  7     10 
          { if (tmp==5) tmp++;       // freq[5]  
            k=33;
            while (k==33) key();              //  
           
            freq[tmp]=k;         //      LCD
            prom=freq[tmp]*m;                //  
            write(k+0x30);          // ,  
            m=m/10;                  //  
            k_sum=k_sum+prom;          //  
          }
      cl(0xC0);
      for (tmp=0; tmp<9; tmp++) write(' ');   //   
                          
   cl(0x80);
   write(vfo);
   write('>');
   lcd_set(freq);                   //    LCD
   k_sum=k_sum*10;                  //   1 
   g=0;
   f_dds=0;

   g=(k_sum+IF) / 10;                //  

   f_set();                        //     DDS
   
   dds_set(f_dds);                  //   DDS
  k=33;
  }



// -------------------------------------------------------------------  A/B  -------------
void ab()                          //    VFO
   {
    write_vfo();    //   
   
    if (vfo=='A') vfo='B';            //  VFO ?
       else vfo='A';
      
    read_vfo();                   //   VFO
  
   
   cl(0x80);
   write(vfo);                    //  vfo>
   write('>');
   lcd_set(freq);                   //    LCD
   dds_sum();                     //   freq[]     
   
   f_set();                        //     DDS
   
   dds_set(f_dds);                  //   DDS
   
   if (split_on) lcd_split(); 
   k=33;
   }

// -------------------------------------------------------------------------  A=B  ------------
void a_b()                 //  =
   {
   if (vfo=='A')         
        {vfo='B';
         write_vfo();     //   vfo    vfo
         vfo='A';         
        }
   if (vfo=='B')
        {vfo='A';
         write_vfo();
         vfo='B';
        }
        
    cl(0x80);           //      A=B
     write('A');
     write('=');
     write('B');
     cl(0x80);
     delay(300);
     delay(300);
     
     write(vfo);
     write('>');
     lcd_set();
     k=33;
   }

// ---------------------------------------------------------------- mem input  ------------------
void mem_in()                        //     
   {int adr=0, tmp;
    
    cl(0xC0);
    
    write('I');
    write('n');
    write('>');
         
         k=33;
         while (k==33) key();        //      
         write(k+0x30);
         
         adr=k*0x10+0x50;
           for (tmp=0; tmp<=7; tmp++)           
                 { if (tmp==5)               // freq[5]  
                        {tmp++;
                         adr++; }
                         
                  EEPROM_WRITE(adr, freq[tmp]);
                  while (WR) NOP;           // ,    
                  adr++;
                }
       
            adr++;
            EEPROM_WRITE(adr, mode);  //  
            while (WR) NOP; 
       
            adr++;
            EEPROM_WRITE(adr, pr);    //  
            while (WR) NOP; 
       
            adr++;
            EEPROM_WRITE(adr, at);    //  
            while (WR) NOP; 
       
       
       
       
       cl(0x80);
       write(vfo);
       write('>');
       lcd_set(freq);
     k=33;
   }
// --------------------------------------------------------------  LCD_SUM  ---------------------------
void lcd_sum()      //  g  freq[]
   {int tmp;
    long m=1000000;
    g=g*10-IF;
    g=g/10;
    for (tmp=0; tmp<=7; tmp++)
            {if (tmp==5) tmp++;
             freq[tmp]=g/m;
             g=g-(freq[tmp]*m);
             m=m/10;
            
            }
    
   
   }


// ---------------------------------------------------------------- mem output  ------------------
void mem_out()                    //   
   {int adr=0, tmp;
    
    cl(0xC0);
    
    write('O');
    write('u');
    write('t');
    write('>');
         
         k=33;
         while (k==33) key();      //    
         write(k+0x30);
        
         adr=k*0x10+0x50;

           for (tmp=0; tmp<=7; tmp++)
                {
                  if (tmp==5) 
                       {tmp++;
                        adr++; }
                  freq[tmp]=EEPROM_READ(adr);
                  while (RD) NOP;
                  adr++;
                }
           adr++;
           mode=EEPROM_READ(adr);         //  
           while (RD) NOP;
       
           adr++;
           pr=EEPROM_READ(adr);           //  
           while (RD) NOP;
       
           adr++;
           at=EEPROM_READ(adr);           //  
           while (RD) NOP;
       
          att();
          pre();
       
          mode_prog();  //  
       
       dds_sum();
       f_set();   
       dds_set(f_dds);     //   DDS
       lcd_sum();          //  g       freq[]
       cl(0x80);
       write(vfo);
       write('>');
       lcd_set(freq);
       k=33;

   }

// ----------------------------------------------------------------  RIT  ------------------------
void rit()                     //   
   {
    rit_on=!rit_on;
    if (rit_on)              //  , 
       {lcd_rit();           //   
       
        write_vfo();
       }  
     else                    //  , 
        {cl(0x8D);           //  
        write(' ');
        write(' ');
        write(' ');
        read_vfo();
        dds_sum();                     //   freq[]     
        f_set(g);                        //     DDS
        dds_set(f_dds);                  //   DDS
        cl(0x82);
        lcd_set(freq);
 
        }
   k=33;
    }

// ----------------------------------------------  RIT_TX  ------------------------   
void rit_tx()                          //  RIT  
   {int tmp, adr=0x20;
      
     if (tx) 
     {
      for (tmp=0; tmp<=7; tmp++)           //   
         {if (tmp==5)               // freq[5]  
              {tmp++;
               adr++;
              }
          EEPROM_WRITE(adr, freq[tmp]);
          while (WR!=0) NOP;           // ,    
          adr++;
          }    
     read_vfo();

     }
     
     if (!tx) 
          {adr=0x20;
           for (tmp=0; tmp<=7; tmp++)
              {if (tmp==5) 
                   {tmp++;
                    adr++;
                   }
                freq[tmp]=EEPROM_READ(adr);
                while (RD) NOP;
                adr++;
              }
         }
     
    dds_sum();                     //   freq[]     
    f_set();                        //     DDS
    dds_set(f_dds);                  //   DDS
    cl(0x82);
    lcd_set(freq);
 k=33;
   }     

// ----------------------------------------------------------------  TX RIT  ---------------------
void tit()
   {int tmp=0, adr=0x20;
    for (tmp=0; tmp<=7; tmp++)
              {if (tmp==5) 
                   {tmp++;
                    adr++;
                   }
                freq[tmp]=EEPROM_READ(adr);
                while (RD) NOP;
                adr++;
              }
      k=33;        
   }
   

// ---------------------------------------------------------------  BAND  -------------------------
void band()                  //  
   {
    
    cl(0xC0);
    write('B');
    write('A');
    write('N');
    write('D');
    write('>');
    k=33;
        while (k==33) key();         // ,  ,  
     
            if (k==1)  { freq[0]=0;  //    
                         freq[1]=1;
                         freq[2]=9;
                         PORTB=0;
                       }
                
            if (k==2) { freq[0]=0;
                        freq[1]=3;
                        freq[2]=6;
                        PORTB=1;
                       }
         
            if (k==3) { freq[0]=0;
                        freq[1]=7;
                        freq[2]=0;
                        PORTB=0x02;
                      }
      
            if (k==4) { freq[0]=1;
                        freq[1]=0;
                        freq[2]=1;
                        PORTB=0x03;
                       }
      
            if (k==5) { freq[0]=1;
                        freq[1]=4;
                        freq[2]=2;
                        PORTB=0x04;
                       }
      
            if (k==6) { freq[0]=1;
                        freq[1]=8;
                        freq[2]=1;
                        PORTB=0x05;
                       }
      
            if (k==7) { freq[0]=2;
                        freq[1]=1;
                        freq[2]=2;
                        PORTB=0x06;
                       }
      
           if (k==8) { freq[0]=2;
                       freq[1]=4;
                       freq[2]=9;
                       PORTB=0x06;
                      }
      
           if (k==9) { freq[0]=2;
                       freq[1]=8;
                       freq[2]=2;
                       PORTB=0x06;
                     }
           if (k==0) { freq[0]=5;
                       freq[1]=0;
                       freq[2]=0;
                       PORTB=0x07;
                     }  
          freq[3]=0;
          freq[4]=0;
          freq[6]=0;
          freq[7]=0;
        k=33;               
      
       dds_sum();
       f_set();   
       dds_set(f_dds);     //   DDS
       lcd_sum();          //  g       freq[]
       cl(0x80);
       write(vfo);
       write('>');
       lcd_set(freq);
       mode_prog();
       k=33;
   }

// -------------------------------------------------------  F_MINUS  ------------------
void f_minus()          //     
  {
  
    f_dds=0;
    dds_sum();
    g=g-step;           // 10 =  100 
   
  }

// -------------------------------------------------------  F_PLUS  -----------------------
void f_plus()          //     
  {
  
    
    f_dds=0;
    dds_sum();
    g=g+step;           // 10 =  100 
    
  }
  
// -------------------------------------------------------------------  A/B TX -------------
void ab_tx()                          //    VFO  
   {
    write_vfo();    //   
   
    if (vfo=='A') vfo='B';            //  VFO ?
       else vfo='A';
    read_vfo();                   //   VFO
    dds_sum();                     //   freq[]     
    f_set();                        //     DDS
    dds_set(f_dds);                  //   DDS
    cl(0x82);
    lcd_set(freq);
   if (tx)
     {
    //   lcd_set(freq);                   //    LCD
     }
   }  

// ----------------------------------------------------  ADC ----------------------------
void adc()                   // S-
    {int tmp=0,tmp1=0;

     ADGO=1;
     while (ADGO) {};

          if (ADRESL > s56) tmp1=0;

          if (ADRESL<=s56) tmp1=1;  // 56  161
                         
          if (ADRESL<=s57) tmp1=2;  // 57  161
                         
          if (ADRESL<=s58) tmp1=3;  // 58  159
                         
          if (ADRESL<=s59) tmp1=4;  // 59  148
                         
          if (ADRESL<=s10) tmp1=5;  // +10  106
                         
          if (ADRESL<=s20) tmp1=6;  // +20   92
                         
          if (ADRESL<=s30) tmp1=7;  // +30   80
                                  

          cl(0xC0);
          for (tmp=0; tmp<7; tmp++) write(' ');  //  
          
          cl(0xC0);
          for (tmp=0; tmp < tmp1; tmp++) write(tmp); //     
        
    }
  
// ----------------------------------------------------  TRANSMIT  ---------------------------------
void transmit()
   { 
      if (split_on) ab_tx();

      if (rit_on)  rit_tx();

      while (tx) 
          {adc();
           delay(10);
          }
 
      if (split_on) ab_tx();   
      
      if (rit_on) rit_tx();
    }   



// -----------------------------------------------------  VALCODER  ------------------------------------
void valcoder()
    {


       if (!old1 && !old2)
              { if (!new1) goto minus;
                else goto plus;
              }
              
      if (!old1 && old2)
              { if (new1) goto minus;
                 else goto plus;
              }
              
      if (old1 && !old2)
              { if (!new1) goto minus;
                 else goto plus;
              }
              
      if (old1 && old2)
            { if (new1) goto minus;                
              else goto plus;
              }
             
 
 minus:
    f_minus();
    goto out;
 plus:
    f_plus();
 out:
        
          f_set();

          dds_set(f_dds);     //   DDS
         
          lcd_sum();          //  g       freq[]

          cl(0x82);

          lcd_set(freq);         

        old1=val1;
        old2=val2;

        
    }

// --------------------------------------------- ADC_CAL -----------------------------------
void adc_cal()             //  S-
   { int s_sum, s1, tmp;
     ADGO=1;
     while (ADGO) {};
        
     s_sum=ADRESH;
     s_sum<<=8;
     s_sum+=ADRESL;
     
     cl(0xC0);
     for (tmp=0; tmp<2; tmp++) write(' ');
      cl(0xC0);
     
      write (ADRESH + 0x30);
     s1 = ADRESL >> 4 & 0xF;
        if (s1 > 9) s1+=0x7;
       write (s1+0x30);
     s1 = ADRESL & 0xF;
        if (s1 > 9) s1+=0x8;
        write(s1+0x30);
     
   }


// ----------------------------------------------  SETUP  -----------------------------------  

void setup()
     {int tmp, adr=0xF0;
      long m=10000000;
      
      clear();
      write('I');
      write('F');
      write('=');
      
      for (tmp=0; tmp<8; tmp++)
           {write(EEPROM_READ(adr)+0x30);
           while (RD) NOP;
           adr++;
           
           }

    k=33;         
    while(k==33) key();
       if (k==5)                        //    5   S-
                {k=33;
                 cl(0x80);
                 write('6');              //   - 6 (56)

read_if();
lcd_set(freq);                   //    LCD
dds_sum();                       //   freq[]     
f_set();                        //     DDS
dds_set(f_dds);                  //   DDS 



                 while (k!=11)          //    >  S-  .
                        {
                           
                           adc_cal();
                           key();
                        }
                 EEPROM_WRITE(0x20,ADRESL);
                
                  k=33;
                 cl(0x80);
                 write('7');              //   - 7 (57)
                 while (k!=11)          //    >  S-  .
                        {
                           adc_cal();
                           key();
                        }
                 EEPROM_WRITE(0x21,ADRESL);
                  
                 k=33;
                 cl(0x80);
                 write('8');              //   - 8 (58)
                 while (k!=11)          //    >  S-  .
                        {
                           adc_cal();
                           key();
                        }
                 EEPROM_WRITE(0x22,ADRESL);
                 
                 k=33;
                 cl(0x80);
                 write('9');              //   - 9 (59)
                 while (k!=11)          //    >  S-  .
                        {
                           adc_cal();
                           key();
                        }
                 EEPROM_WRITE(0x23,ADRESL);
                 
                 k=33;
                 cl(0x80);
                 write('1');              //   - 1 (+10)
                 while (k!=11)          //    >  S-  .
                        {
                           adc_cal();
                           key();
                        }
                 EEPROM_WRITE(0x24,ADRESL);
                 
                 k=33;
                 cl(0x80);
                 write('2');              //   - 2 (+20)
                 while (k!=11)          //    >  S-  .
                        {
                           adc_cal();
                           key();
                        }
                 EEPROM_WRITE(0x25,ADRESL);
                 
                 k=33;
                 cl(0x80);
                 write('3');              //   - 3 (+30)
                 while (k!=11)          //    >  S-  .
                        {
                           adc_cal();
                           key();
                        }
                 EEPROM_WRITE(0x26,ADRESL);
                  k=33;
                 }              

     if (k==4)
     {
      adr=0xF0;
      cl(0xC0);
      write('N');
      write('e');
      write('w');
      write('>');
      
         for (tmp=0; tmp<8; tmp++)
          {
           k=33;
           while (k==33) key();
          
           write(k+0x30);
           EEPROM_WRITE(adr, k);
           while (WR) NOP;
           adr++;
           
           IF=IF+(k*m);
           m=m/10;
          }
      k=33;
     }
  }

// ----------------------------------------------------  READ_IF  ------------------------------
void read_if()               //    
    {int tmp, adr=0xF0, qaz=0;
     long m=10000000;
     IF=0;
      for (tmp=0; tmp<8; tmp++)
          {qaz=EEPROM_READ(adr);
           while (RD) NOP;
           IF=IF+(qaz*m);
           adr++;
           m=m/10;
          }  
    
    }

// ------------------------------------------------- hc595  -----------------------------------
void hc_595()
   {
   SH=0;
   ST=0;
   DS=0;
   
   if (cw & 1) DS = 1;
         else DS = 0;
      hc_strobe;
   if (ssb & 1) DS = 1;
         else DS = 0;
      hc_strobe;
   if (am & 1) DS = 1;
         else DS = 0;
      hc_strobe;
   if (fm & 1) DS = 1;
         else DS = 0;
      hc_strobe;
   if (pr & 1) DS = 1;
         else DS = 0;
      hc_strobe;
   if (at & 1) DS = 1;      //  2 
         else DS = 0;
      hc_strobe;
   if (agc & 1) DS = 1;     //  1 
         else DS = 0;
      hc_strobe;
   DS = 0;                  //  15 
      hc_strobe;
      
   hc_update;
 
   
   }

// ----------------------------------------------- MODE_PROG ----------------------------------------
void mode_prog()
{ 
  if (k==14)
      {if (mode <=1) mode=2;
          else mode=ssb;
      }
  if (k==15)
      {if (mode==3) mode=4;
          else mode=3;
      }
  k=33;
  if (mode <=1) mode=ssb;
  switch (mode)
                 { case 0 : {ssb=0;
                             fm=0;
                             cw=0;
                             am=0;
                             cl(0xCD);
                             write('u');
                             write('s');
                             write('b');
                            }   break;
                   case 1 : {ssb=1;
                             cw=0;
                             fm=0;
                             am=0;
                             cl(0xCD);
                             write('l');
                             write('s');
                             write('b');
                            }   break;
                   case 2 : {cw=1;
                             am=0;
                             fm=0;
                             cl(0xCD);
                             write(' ');
                             write('c');
                             write('w');
                            }   break;
                   case 3 : {fm=1;
                             cw=0;
                             am=0;
                             cl(0xCD);
                             write(' ');
                             write('f');
                             write('m');
                            }   break;
                   case 4 : {am=1;
                             fm=0;
                             cw=0;
                             cl(0xCD);
                             write(' ');
                             write('a');
                             write('m');
                            }   break;
                       
                   default: ;
                        break;  }          // end case
  
  hc_595();
      
}

// ---------------------------------------------- SCAN  ----------------------------------------
void scan(int z)
    {
     while (val1==old1 || val2==old2)
         {   
             if (!z) f_minus();
             if (z) f_plus();
           
            f_set();
            dds_set(f_dds);     //   DDS
            lcd_sum();          //  g       freq[]
            cl(0x82);
            lcd_set(freq);         
         }  
     k=33;    
    }

// -------------------------------------------------  ATT  ------------------------------------
void att()     // 
 {
  cl(0xC8);
    if (at) write('-');
    else write(' ');
    hc_595();
  k=33;
 }

// ------------------------------------------------  Pre  -------------------------------------
void pre()     // 
 {
  cl(0xC9);
     if (pr) write('+');
     else write(' ');
     hc_595();
  k=33;
 }

// ------------------------------------------------ AGC_PROG -----------------------------------
void agc_prog()   //  /
  {agc=!agc;
   cl(0xCB);
    if (agc) write('m');
    else write(' ');
    hc_595();
  k=33;
  
  }

// ---------------------------------------------- FAST ------------------------------------------
  void fast()
    {
      if (fast_flag)	
      	  {step_old=step;
    	  step=100;
    	  cl(0xCC);
    	  write('F');
      	  }
      else
          {step=step_old;
           cl(0xCC);
           write(' ');
          }
    }




//-----------------------------------------------  M  A  I  N  ------------------------------------
//_________________________________________________________________________________________________




main()
{
 TRISA=0b000011;
 TRISB=0b11110000;
 TRISC=0b10000111;
 TRISD=0x00;
 TRISE=0x00;
 PORTA=0x00;
 PORTD=0xFF;
 PORTB=0x04;
 PORTC=0x00;

 ADCON1=0b1110;
 ADCON0=0b01000001;
 ADFM=1;
 RW=0;
 
 fast_flag=0;
 
 s56=EEPROM_READ(0x20);
 s57=EEPROM_READ(0x21);
 s58=EEPROM_READ(0x22);
 s59=EEPROM_READ(0x23);
 s10=EEPROM_READ(0x24);
 s20=EEPROM_READ(0x25);
 s30=EEPROM_READ(0x26);
 
 
 dds_init();
 lcd_init();


 
old1=val1;
old2=val2;

am=0;
fm=0;
cw=0;

//clear();

vfo='A';
read_vfo();
freq[5]=0xA0;        //   
freq_old = freq[0];  //   usb/lsb

if (freq[0]==0) 
          {ssb_pin=1;
           ssb=1;
          }
    else 
          {ssb_pin=0;
           ssb=0;
          }

mode_prog();


st=EEPROM_READ(0x30);        //  
while (RD) NOP;           // ,    

         switch (st)
                 { case 1 : step=1; break;
                   case 2 : step=2; break;
                   case 3 : step=3; break;
                   case 4 : step=4; break;
                   case 5 : step=5; break;
                   case 6 : step=10; break;
                   case 7 : step=100; break;
                   case 8 : step=100000; break;         
                   default: step=1; break;
                  }          // end case


k=33;
key();                     
if (k!=33)  setup();             // SETUP
k=33;

read_if();


hc_595();

cl(0x80);

write_znak();

cl(0x80);
write(vfo);
write('>'); 

lcd_set(freq);                   //    LCD
dds_sum();                       //   freq[]     
f_set();                        //     DDS
dds_set(f_dds);                  //   DDS 



  while (1)
   {a=0;
   k=33;
       
   while (k==33) 
        {key();
        
         if (tx) transmit(); 
         if (val1!=old1 || val2!=old2) 
                      {new1=val1;
                       new2=val2;
                       valcoder();       
                      }
         if (a>20)              //   S-
            {adc();
             a=0;
            }
         a++;
        }


      if (k==1)  step_set();      //  1 -  
                               
      if (k==2) f_in();         //  2 -  
         
      if (k==3) band();         //  3 -     
      
      if (k==4) mem_in();       //  4   
      
      if (k==5) ab();          //  5 - A/B
      
      if (k==6) a_b();          //  6 - A=B
      
      if (k==7) mem_out();      //  7   
      
      if (k==8) rit();          //  8 
      
      if (k==9) {};             //  9  RX/TX
        
      if (k==0) split();        //  0 
      
      if (k==10) scan(0);       //  
          
      if (k==11) scan(1);       //  
     
      if (k==12)                // ATT
               {at=!at;
               att();  
               }       
      
      if (k==13)                // Pre
                {pr=!pr;
                pre();  
                }       
      
      if (k==14) mode_prog();   // ssb/cw
      
      if (k==15) mode_prog();   // fm/am
      
      if (k==16) agc_prog();    //  /.

      if (k==17)               // fast
              {fast_flag=!fast_flag;
               fast();
              }
 
  }
}


